#include <mega128.h>
#include "sub/io.c"    
#include "sub/sys.c"
#include "sub/i1813lcd.c"
         
// Internal RC Oscillator Mode 
//  CKSEL3 CKSEL2 CKSEL1 CKSEL0
//    0      1      0      0     8MHz
        

unsigned int r=0x1f,g=0,b=0,step=0;  
unsigned int color;
void color_bar(void)
{   
  unsigned int n,m;

  LcdSetWindow(0,0,160,128);
  LcdDataStart();

  for(n=0;n<187;n++)
   {     
     color = (r<<11) + (g<<6) + b;
     switch(step)
      {
         case 0:
           g++;
           if(g==0x1f) step=1;
         break;
           
         case 1:
           r--;
           if(r==0) step=2;
         break;
           
         case 2:
           b++;
           if(b==0x1f) step=3;
         break;
           
         case 3:
           g--;
           if(g==0) step=4;
         break;
           
         case 4:
           r++;
           if(r==0x1f) step=5;
         break;
           
         case 5:
           b--;
           if(b==0) step=0;
           
         default:
         break;
      }
     if(n<128)
      {
        for(m=0;m<160;m++)
         { 
           LcdData(color);
         }
      }
   }
  LcdDataEnd();          

}

         
void main(void)
{ 
  unsigned int n,m;

  io_init();
  Sini(0,384,0);

  LcdBl(1);
  LcdInit();           
       
  LcdSetDirection(270);  
  LcdSetWindow(0,0,160,128);
  LcdDataStart();
  for(n=0;n<128;n++)
   {  for(m=0;m<160;m++) LcdData(0xf800);  //red
   }
  LcdDataEnd();

  mdelay(1000);
  
  LcdDataStart();
  for(n=0;n<128;n++)
   {  for(m=0;m<160;m++) LcdData(0x07e0);  //green
   }
  LcdDataEnd();    

  mdelay(1000);

  LcdDataStart();
  for(n=0;n<128;n++)
   {  for(m=0;m<160;m++) LcdData(0x001f);  //blue
   }
  LcdDataEnd();
               
  mdelay(1000);
  
  while(1)
  {  
     color_bar();
  }
}


